import React from 'react'

class Liner extends React.Component {
  constructor (props) {
    super(props)
    this.handle = this.handle.bind(this)
  }

  handle () {
    // If nothing or more than one thing is selected, do nothing
    const selection = window.getSelection()
    if (selection.rangeCount !== 1) return

    // If selection is outside children, do nothing
    const range = selection.getRangeAt(0)
    const ancestor = range.commonAncestorContainer
    if (!this.reference.contains(ancestor)) return

    const text = this.reference.textContent
    const prefix = text.slice(0, range.startOffset)
    const suffix = text.slice(range.endOffset)
    const exact = text.slice(range.startOffset, range.endOffset)

    this.props.onSelect({
      prefix, suffix, exact
    })
  }

  render () {
    return (
      <div ref={(child) => { this.reference = child }} onClick={this.handle}>
        {this.props.children}
      </div>
    )
  }
}

export default Liner
