const path = require('path')
const fs = require('fs')

const srcFolder = path.join(__dirname, 'src/components')
const components = fs.readdirSync(srcFolder)

const files = []
const entries = {}
components.forEach(component => {
  const name = component.split('.')[0]
  const file = `./src/components/${name}`
  files.push(file)
  entries[name] = file
})

module.exports = {
  entry: entries,
  output: {
    filename: '[name].js',
    path: path.join(__dirname, 'lib/components/'),
    libraryTarget: 'commonjs2'
  },
  externals (context, request, callback) {
    // Do not treat icon files as external
    if (files.indexOf(request) > -1) {
      return callback(null, false)
    }
  },
  module: {
    loaders: [
      {
        test: /\.js/,
        loader: 'babel-loader',
        include: path.join(__dirname, 'src')
      }
    ]
  }
}
